'-- This script demonstrates accessing the list of running processes in jsShell.
'-- For each process there is an executable path and a processID.
'-- The PID can be used in conjunction with Windows.GetWindowPID to match the executable 
'-- of a given process with a given by getting the handle (hWnd) of that window, getting the 
'-- PID from that, and then comparing the PID to the PIDs returned in the running process list. 

Dim jsS, jsSProcs, iCount, i2, sList, PID3, Path3
  Set jsS = CreateObject("jsShell.Ops")
  
Set jsSProcs = jsS.GetRunningProcesses
  
iCount = jsSProcs.ProcessCount

MsgBox "Process count: " & iCount

For i2 = 1 to iCount
  sList = sList & i2 & ": " & jsSProcs.GetPathByIndex(i2) & vbCrLf & jsSProcs.GetPIDByIndex(i2) & vbCrLf
  If i2 = 3 Then  
     Path3 = jsSProcs.GetPathByIndex(i2)
     PID3 = jsSProcs.GetPIDByIndex(i2)
   End If  
Next

MsgBox sList

MsgBox "Process number 3 PID from path string snippet: " &  jsSProcs.GetPIDByString(right(Path3, 12)) & vbCrLf & "PID number 3: " & PID3

MsgBox "Process number 3 path from PID: " & jsSProcs.GetPathByPID(PID3) & vbCrLf & "Path of process number 3 executable: " & Path3

Set jsSProcs = Nothing
   Set jsS = Nothing